package ca.hivesolutions.toughpad

import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry.Registrar

import io.flutter.plugin.common.BasicMessageChannel

import ca.hivesolutions.BarcodeReader.BarcodeReaderSrv
import android.app.Activity
import io.flutter.plugin.common.StringCodec
import java.util.concurrent.TimeUnit
import io.reactivex.rxkotlin.subscribeBy

public class ToughpadPlugin(activity: Activity, readBarcodesChannel: BasicMessageChannel<String>): MethodCallHandler {
    private var barcodeReaderSrv: BarcodeReaderSrv = BarcodeReaderSrv.instance;

    companion object {
        @JvmStatic
        fun registerWith(registrar: Registrar) {
            val channel = MethodChannel(registrar.messenger(), "barcode")

            val readBarcodesChannel = BasicMessageChannel<String>(registrar.messenger(), "readBarcodes", StringCodec.INSTANCE)

            channel.setMethodCallHandler(ToughpadPlugin(registrar.activity(), readBarcodesChannel))
        }
    }

    init {
        barcodeReaderSrv.init(activity)

        barcodeReaderSrv.barcode
//         .timeout(10, TimeUnit.SECONDS)
         .subscribeBy(
             onNext = {
                 var readBarcode = it.toString()
                 readBarcodesChannel.send(readBarcode) { reply ->
//                     Log.i("MSG", reply)
                 }
             },
             onError = {
//                 barcodeReaderSrv.stopBarcodeScan()
             }
         )


    }



    override fun onMethodCall(call: MethodCall, result: Result) {
        if (call.method == "startBarcodeScan") {
            barcodeReaderSrv.reset()
            barcodeReaderSrv.startBarcodeScan()
            result.success("")
        } else if (call.method == "stopBarcodeScan") {
            barcodeReaderSrv.stopBarcodeScan()
            result.success("")
        } else {
            result.notImplemented()
        }

        // await resultData;
    }
}

