import 'dart:async';
import 'package:rxdart/rxdart.dart';
import 'package:flutter/services.dart';

class Toughpad {
  static const MethodChannel _channel = const MethodChannel('barcode');
  static final readBarcodes = new BehaviorSubject<String>.seeded("");
  static const BasicMessageChannel<String> _readBarcodesChannel = BasicMessageChannel<String>('readBarcodes', StringCodec());

  static Future<String> startBarcodeScan() async {
    final String result = await _channel.invokeMethod('startBarcodeScan');
    return result;
  }

  static Future<String> stopBarcodeScan() async {
    final String result = await _channel.invokeMethod('stopBarcodeScan');
    return result;
  }

  static Future<void> init() async {
    _readBarcodesChannel.setMessageHandler((String message) async {
      readBarcodes.add(message);
      print('Received: $message');
      return '';
    });
  }
}